#include "load_exr.h"

using namespace Imf;
using namespace Imath;

// load an OpenEXR format image from disk
Array2D<Rgba> *
load_OpenEXR(char *filename, int &width, int &height)
{
  RgbaInputFile file (filename);
  Array2D<Rgba> *pixels = new Array2D<Rgba>;

  Box2i dw = file.dataWindow();
  width = dw.max.x - dw.min.x + 1;
  height = dw.max.y - dw.min.y + 1;
  pixels->resizeErase (height, width);

  file.setFrameBuffer (&(*pixels)[height-1][0], 1, -width);  // flip image vertically
  file.readPixels (dw.min.y, dw.max.y);
  return pixels;
}
